﻿using System;
using System.Collections.Generic;
using JsonRpcLite.Services;

namespace TestServer
{

    [RpcService("test1")]
    public class TestService
    {
        [RpcMethod("internal.echo")]
        public string Handle_Echo(string s)
        {
            return s;
        }

        [RpcMethod]
        public string myIp()
        {
            return "IP not available";
        }

        [RpcMethod]
        public string myUserAgent()
        {
            return "hmm. no UserAgent";
        }

        [RpcMethod("error1")]
        public string devideByZero(string s)
        {
            var i = 0;
            var j = 15;
            return s + j / i; // This causes the framework to throw an exception
        }

        [RpcMethod("error2")]
        public string throwsException(string s)
        {
            throw new InvalidOperationException("Unhandled exception.");
        }

        [RpcMethod("error3")]
        public string throwsException2(string s)
        {
            throw new ServerErrorException("Unhandled exception.");
        }

        [RpcMethod("error4")]
        public string throwsException3(string s)
        {
            
            return s;
        }

        [RpcMethod]
        public string RequiresCredentials(string magicKey)
        {
            return "Passed Authentication";
        }

        [RpcMethod]
        public DateTime testDateTime()
        {
            return DateTime.Now;
        }

        [RpcMethod]
        public recursiveClass testRecursiveClass()
        {
            var obj = new recursiveClass() { Value1 = 10, Nested1 = new recursiveClass() { Value1 = 5 } };
            //obj.Nested1.Nested1 = obj;
            return obj;
        }

        [RpcMethod]
        public List<string> testFloat(float input)
        {
            return new List<string>() { "one", "two", "three", input.ToString() };
        }

        [RpcMethod]
        public List<string> testInt(int input)
        {
            return new List<string>() { "one", "two", "three", input.ToString() };
        }

        [RpcMethod]
        public object[] testMultipleParameters(string one, int two, float three, CustomString four)
        {
            return new object[] { one, two, three, four };
        }

        [RpcMethod("testSimpleString")]
        public List<string> testSimpleString(string input)
        {
            return new List<string>() { "one", "two", "three", input };
        }

        [RpcMethod]
        public List<string> testThrowingException(string input)
        {
            throw new Exception("Throwing Exception");
            return new List<string>() { "one", "two", "three", input };
        }

        public class CustomString
        {
            public string str;
        }

        [RpcMethod("testCustomString")]
        public List<string> testCustomString(CustomString input)
        {
            return new List<string>() { "one", "two", "three", input.str };
        }

        public class recursiveClass
        {
            public recursiveClass Nested1 { get; set; }
            public int Value1 { get; set; }
        }
    }
}
